package com.example.switchyard.BpmEqSearch;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;


import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.custommonkey.xmlunit.XMLAssert;
import org.custommonkey.xmlunit.XMLUnit;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(config = SwitchYardTestCaseConfig.SWITCHYARD_XML, mixins = { CDIMixIn.class })
public class EquipmentConfigurationServicesTrfTest {

	private SwitchYardTestKit testKit;
	private CDIMixIn cdiMixIn;
	@ServiceOperation("EquipmentConfigurationServices.equipmentSearchSoa")
	private Invoker equipmentSearchSoa;

	 final String INPUT_XML = "xml/input.xml";
	 final String RESULT_XML = "xml/output.xml";

//	@Test
//	public void testEquipmentSearchSoa() throws Exception {
//		// TODO Auto-generated method stub
//		// initialize your test message
//		Object message = null;
//		Object result = service.operation("equipmentSearchSoa")
//				.sendInOut(message).getContent(Object.class);
//
//		// validate the results
//		Assert.assertTrue("Implement me", false);
//	}
	
    @Test
    public void testTransformXMLtoJava() throws Exception {

        Output  output = equipmentSearchSoa
            .inputType(QName.valueOf("{urn:com.example.switchyard:BpmEqSearch:1.0}equipmentSearchSoa"))
            .sendInOut(loadXML(INPUT_XML).getDocumentElement())
            .getContent(Output.class);

        Assert.assertTrue(true);

    }

    @Test
    public void testTransformJavaToXML() throws Exception {
        Input input = new Input()
            .setCompanyId("EDI")
            .setPassword("1234")
            .setLanguage("pt")
            .setUsrId("nfgl")
            .setData("<![CDATA[&lt;EquipSearchList&gt;&lt;EquipSearch&gt;&lt;reference&gt;101014930807&lt;/reference&gt;&lt;/EquipSearch&gt;&lt;/EquipSearchList&gt;]]>");

        Element result = equipmentSearchSoa
            .expectedOutputType(QName.valueOf("{urn:com.example.switchyard:BpmEqSearch:1.0}searchEquipmentSoaResponse"))
            .sendInOut(input)
            .getContent(Element.class);
        XMLUnit.setIgnoreWhitespace(true);
        XMLAssert.assertXMLEqual(loadXML(RESULT_XML), result.getOwnerDocument());
    }

    private Document loadXML(String path) throws Exception {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setNamespaceAware(true);
        DocumentBuilder db = dbf.newDocumentBuilder();
        return db.parse(getClass().getClassLoader().getResourceAsStream(path));
    }








}
